"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  H: () => H
});
module.exports = __toCommonJS(src_exports);

// src/sdk.ts
var import_performance = require("opentelemetry-sdk-workers/performance");
var import_OTLPProtoLogExporter = require("opentelemetry-sdk-workers/exporters/OTLPProtoLogExporter");
var import_OTLPProtoTraceExporter = require("opentelemetry-sdk-workers/exporters/OTLPProtoTraceExporter");
var import_resources = require("@opentelemetry/resources");
var import_opentelemetry_sdk_workers = require("opentelemetry-sdk-workers");
var HIGHLIGHT_PROJECT_ENV = "HIGHLIGHT_PROJECT_ID";
var HIGHLIGHT_REQUEST_HEADER = "X-Highlight-Request";
var HIGHLIGHT_OTLP_BASE = "https://otel.highlight.io";
var RECORDED_CONSOLE_METHODS = [
  "debug",
  "error",
  "info",
  "log",
  "warn"
];
var sdk;
var H = {
  // Initialize the highlight SDK. This monkeypatches the console methods to start sending console logs to highlight.
  init: (request, { [HIGHLIGHT_PROJECT_ENV]: projectID }, ctx, service) => {
    const [sessionID, requestID] = (request.headers.get(HIGHLIGHT_REQUEST_HEADER) || "").split("/");
    const endpoints = { default: HIGHLIGHT_OTLP_BASE };
    sdk = new import_opentelemetry_sdk_workers.WorkersSDK(request, ctx, {
      service: service || "cloudflare-worker",
      consoleLogEnabled: false,
      traceExporter: new import_OTLPProtoTraceExporter.OTLPProtoTraceExporter({
        url: `${endpoints.default}/v1/traces`
      }),
      logExporter: new import_OTLPProtoLogExporter.OTLPProtoLogExporter({
        url: `${endpoints.default}/v1/logs`
      }),
      resource: new import_resources.Resource({
        ["highlight.project_id"]: projectID,
        ["highlight.session_id"]: sessionID,
        ["highlight.trace_id"]: requestID
      })
    });
    for (const m of RECORDED_CONSOLE_METHODS) {
      const originalConsoleMethod = console[m];
      console[m] = (message, ...args) => {
        sdk.logger[m].apply(sdk.logger, [message, ...args]);
        originalConsoleMethod.apply(originalConsoleMethod, [
          message,
          ...args
        ]);
      };
    }
    return sdk;
  },
  // Capture a javascript exception as an error in highlight.
  consumeError: (error) => {
    if (!sdk) {
      console.error(
        "please call H.init(...) before calling H.sendResponse(...)"
      );
      return;
    }
    console.log("H.consumeError", error);
    sdk.captureException(error);
  },
  // Capture a cloudflare response as a trace in highlight.
  sendResponse: (response) => {
    if (!sdk) {
      console.error(
        "please call H.init(...) before calling H.sendResponse(...)"
      );
      return;
    }
    sdk.sendResponse(response);
  },
  // Set custom attributes on the errors and logs reported to highlight.
  // Setting a key previously set will update the value.
  setAttributes: (attributes) => {
    if (!sdk) {
      console.error(
        "please call H.init(...) before calling H.setAttributes(...)"
      );
      return;
    }
    sdk.traceProvider.resource = sdk.traceProvider.resource.merge(
      new import_resources.Resource(attributes)
    );
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  H
});
